# TODO: to zadanie bardziej pasuje do function_parameters
# TODO: Translate input data to English
# TODO: zamieniać wiele spacji na jedną, a nie na pusty znak
"""
* Assignment: Function Arguments Clean
* Type: homework
* Complexity: medium
* Lines of code: 15 lines
* Time: 13 min

English:
    1. Define function `clean`:
        a. parameter `text: str` (required)
        b. returns `str` with cleaned text
    2. To clean text:
        a. Remove unwanted whitespaces
        b. Remove unwanted special characters
        c. Remove unwanted fragments
        d. Format text
    3. Run doctests - all must succeed

Polish:
    1. Zdefiniuj funkcję `clean`:
        a. parametr `text: str` (wymagany)
        b. zwraca `str` z oczyszczonym tekstem
    2. Aby oczyścić tekst:
        a. Usuń niechciane białe znaki
        b. Usuń niechciane znaki specjalne
        c. Usuń niechciane fragmenty
        d. Sformatuj tekst
    3. Uruchom doctesty - wszystkie muszą się powieść

Tests:
    >>> import sys; sys.tracebacklimit = 0
    >>> from inspect import isfunction

    >>> assert clean is not Ellipsis, \
    'Write solution inside `clean` function'
    >>> assert isfunction(clean), \
    'Object `clean` must be a function'

    >>> clean('ul.Mieszka II')
    'Mieszka II'
    >>> clean('UL. Zygmunta III WaZY')
    'Zygmunta III Wazy'
    >>> clean('  bolesława chrobrego ')
    'Bolesława Chrobrego'
    >>> clean('ul Jana III SobIESkiego')
    'Jana III Sobieskiego'
    >>> clean('\tul. Jana trzeciego Sobieskiego')
    'Jana III Sobieskiego'
    >>> clean('ulicaJana III Sobieskiego')
    'Jana III Sobieskiego'
    >>> clean('UL. JA    NA 3 SOBIES  KIEGO')
    'Jana III Sobieskiego'
    >>> clean('ULICA JANA III SOBIESKIEGO  ')
    'Jana III Sobieskiego'
    >>> clean('ULICA. JANA III SOBIeskieGO')
    'Jana III Sobieskiego'
    >>> clean(' Jana 3 Sobieskiego  ')
    'Jana III Sobieskiego'
    >>> clean('Jana III Sobi  eskiego ')
    'Jana III Sobieskiego'
"""

# Define function `clean`:
# - parameter `text: str` (required)
# - returns `str` with cleaned text
#
# To clean text:
# - Remove unwanted whitespaces
# - Remove unwanted special characters
# - Remove unwanted fragments
# - Format text
# type: Callable[[str], str]
...


# Solution
def clean(text):
    return (text

            # Convert to common format
            .upper()

            # Remove unwanted whitespaces
            .replace('\n', '')
            .replace('\t', '')
            .replace('     ', '')
            .replace('    ', '')
            .replace('   ', '')
            .replace('  ', '')

            # Remove unwanted special characters
            .replace('.', '')
            .replace(',', '')
            .replace('-', '')
            .replace('|', '')

            # Remove unwanted fragments
            .replace('ULICA', '')
            .replace('UL', '')
            .replace('TRZECIEGO', 'III')
            .replace('3', 'III')

            # Formatting
            .title()
            .replace('Iii', 'III')
            .replace('Ii', 'II')
            .strip()
    )
